# CLEAN VERSION

This is the clean code version for submission to CoRL, developed on branch clean_corl
from a private repository. 



# Files To Run And Useful Information

There are several files designed to allow for quick demonstrations of methodology. First, use the commands in How_To_Make_Conda_Environment.txt to construct a conda environment. Then, the following notebooks should work. Some of the results-generating scripts are included here but have long run times. For all listed files, please run any Jupyter notebooks by block, and look through the existing output first to see what is already produced! 

### Baselines/data
    - baselines/data/HJ_Racer.ipynb
    - baselines/data/HJ_Strelka.ipynb

These files (open and run block-by-block) illustrate the HJ baseline methodology for the Racer (simulated) and Strelka (Go1 quadruped -- physical hardware). 

### Racer/reachability

The following are read-only (some anonymized cross-system compatibility challenges): 
    - centerline_environment_demo.ipynb
    - pedestrian_environment_demo.ipynb
    - random_environment_demo.ipynb

These files illustrate the outputs of the animation generation

The following file allows a sweep of the slalom setting referenced in Supp. D
- Main_Experiment_Notebook.ipynb

### images/
All used images are stored here (Supp. D)

